Package: iterativeBMA
Type: Package
Title: The Iterative Bayesian Model Averaging (BMA) algorithm
Version: 1.71.0
Date: 2009-7-22
Author: Ka Yee Yeung, University of Washington, Seattle, WA, with
        contributions from Adrian Raftery and Ian Painter
Maintainer: Ka Yee Yeung <kayee@u.washington.edu>
Description: The iterative Bayesian Model Averaging (BMA) algorithm is
        a variable selection and classification algorithm with an
        application of classifying 2-class microarray samples, as
        described in Yeung, Bumgarner and Raftery (Bioinformatics 2005,
        21: 2394-2402).
Depends: BMA, leaps, Biobase (>= 2.5.5)
License: GPL (>= 2)
URL: http://faculty.washington.edu/kayee/research.html
biocViews: Microarray, Classification
git_url: https://git.bioconductor.org/packages/iterativeBMA
git_branch: devel
git_last_commit: c138cda
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-05-18
NeedsCompilation: no
Packaged: 2026-05-18 22:28:57 UTC; biocbuild
Built: R 4.6.0; ; 2026-05-19 04:56:20 UTC; unix

## iterative bic.glm in R: 
zero.threshold <- 0.0001

iterateBMAglm <- function (x, y, curr.mat, stopVar=0, nextVar, nbest=10, thresProbne0 = 1, maxNvar = 30, maxIter=20000) {

   ## iterative bic.glm
   currIter <- 0
   while (stopVar == 0 && currIter < maxIter) {
   	## run bic.glm from the BMA package
   	ret.bic.glm <- bic.glm (x=curr.mat, y=y, maxCol=(maxNvar+1), glm.family="binomial", nbest=nbest)

   	## get a logical vector for which probne0 < thresProbne0
   	rmVector <- which (ret.bic.glm$probne0 < thresProbne0)

	## now, check if we could add more variables
	## We want to run bic.glm with as many variables as possible
	## so that we are considering more models simultaneously AND
	## for efficiency reasons
	if (length(ret.bic.glm$probne0) < maxNvar) {
	  ## we have extra space, so we want to add variables
	  add.slots <- maxNvar - length(ret.bic.glm$probne0)
	  ## stuff up curr.mat with junk, to be removed later
	  num.var.to.add <- ncol(x) - nextVar + 1
	  if (num.var.to.add > length(rmVector)) {
	     ## we only add if we have more variables left to add than
	     ## space from removing low threshold ones
	     num.spots.needed <- num.var.to.add - length(rmVector)
	     junk.ncol <- min (num.spots.needed, add.slots)
	     junk.mat <- matrix(0, nrow=nrow(curr.mat), ncol=junk.ncol)
	     curr.mat <- cbind (curr.mat, junk.mat)
	     rmVector.old <- rmVector
	     rmVector <- c(rmVector.old, (length(ret.bic.glm$probne0)+1):(length(ret.bic.glm$probne0)+junk.ncol))
	  }
	}

	## only increase thresProbne0 if there is no space to add in variables
	if (length(rmVector) == 0) {
	  ## we only end up here if length(ret.bic.glm$probne0) >= maxNvar
	  ## no gene to swap in!!, increase threshold
	  currMin <- min (ret.bic.glm$probne0)
	  print (paste("no gene to swap! Min probne0 = ", currMin, sep=""))
          newThresProbne0 <- currMin + 1
	  print (paste("new probne0 threshold = ", newThresProbne0, sep=""))
	  rmVector <- which (ret.bic.glm$probne0 < newThresProbne0)
	  ## print (rmVector)
	}

  	## now, guaranteed there is at least 1 variable to swap
	## or there is space to add in new variables

	if (nextVar <= ncol(x)) {
	   ## set up new X
	   ## print ("set up new X")
	   lastVar <- length(rmVector) + nextVar - 1
	   ## to make sure lastVar <= ncol(x)
	   if (lastVar > ncol(x)) {
	     rmVector <- rmVector [1: (ncol(x) -nextVar + 1)]
	     lastVar <- ncol(x)
           }
	   ## print (paste(nextVar, lastVar, sep=" "))
	   ##print (dimnames(x)[[2]][nextVar:lastVar])
	   
	   ## check for singularity
	   curr.mat[, rmVector] <- x[, nextVar:lastVar]
	   ## change the colume name as well!!
	   dimnames(curr.mat)[[2]][rmVector] <- dimnames(x)[[2]][nextVar:lastVar]
	   svd.out <- svd (curr.mat)

           if (any(svd.out$d < zero.threshold) == TRUE) {
		## singularity, try to add one variable at a time
		print ("inside svd")
		curr.mat <- curr.mat[, -(rmVector)]
		for (curr.var in nextVar:lastVar) {
		   orig.dimnames <- dimnames (curr.mat)[[2]]
		   curr.mat <- cbind (curr.mat, x[, curr.var])
		   dimnames(curr.mat)[[2]] <- c(orig.dimnames, dimnames(x)[[2]] [curr.var])
		   svd.out <- svd (curr.mat)
		   if (any(svd.out$d < zero.threshold) == TRUE) {
			## NOT okay to add this variable, rm the last column
			curr.mat <- curr.mat[, -(ncol(curr.mat))]
		   }
		}
      	   }

	   nextVar <- lastVar + 1

       	} else {
	   ## there is no variable to be removed OR exhausted all data
           stopVar <- 1
        }
	currIter <- currIter + 1
   }
   print (paste(currIter, ": explored up to variable ## ", nextVar-1, sep=""))
  
   ## print out selected genes if iterateBMA is over
   if (stopVar == 1) {
	selectedGenes <- which(ret.bic.glm$probne0 >= thresProbne0)
   }
   
   list(curr.mat=curr.mat, stopVar=stopVar, nextVar=nextVar)
}


iterateBMAinit <- function (x, maxNvar = 30) {

   maxNvar <- min (maxNvar, ncol(x))
   curr.mat <- x[, 1:maxNvar]
   stopVar <- 0
   nextVar <- maxNvar + 1

   ## make sure the curr.mat is not singular
   svd.out <- svd (curr.mat)

   ## successively add a column
   ## if a variable causes singularity --> a linear combination of others
   ##           --> just ignore this variable
   if (any(svd.out$d < zero.threshold) == TRUE) {
	## start by adding 1 variable at a time
	curr.mat <- as.matrix(x[, 1])
	dimnames (curr.mat)[[2]] <- as.vector(dimnames(x)[[2]][1], mode="list") 
	curr.var <- 2
	while ((ncol(curr.mat) < maxNvar) && (curr.var <= ncol(x))) {
	  orig.dimnames <- dimnames (curr.mat)[[2]]
	  curr.mat <- cbind (curr.mat, x[, curr.var])
	  dimnames(curr.mat)[[2]] <- c(orig.dimnames, dimnames(x)[[2]] [curr.var])
	  print (paste("iterateBMAinit: add 1 column --> total ", ncol(curr.mat), sep=""))
	  svd.out <- svd (curr.mat)
	  if (any(svd.out$d < zero.threshold) == TRUE) {
		## NOT okay to add this variable, rm the last column
	  	orig.dimnames.2 <- dimnames (curr.mat)[[2]]
		orig.dimnames.1 <- dimnames (curr.mat)[[1]]
		col.to.rm <- ncol(curr.mat)
		curr.mat <- as.matrix (curr.mat[, -(col.to.rm)])
		dimnames(curr.mat) <- list(orig.dimnames.1, orig.dimnames.2[-col.to.rm])
		print (paste ("variables dropped: ", ncol(curr.mat)+1, sep=""))
	  }
	  curr.var <- curr.var + 1
	}
	## here, ncol(curr.mat) >= maxNvar OR curr.var > ncol(x)
	nextVar <- curr.var
   }

   list(curr.mat=curr.mat, stopVar=stopVar, nextVar=nextVar)
}



## parameters: nbest: input to bicglm
##             sortedA: matrix of independent variables, sorted by columns
##                  expected G * C, all of our data
##             y: vector of response
##             thresProbne0: threshold to rm probne0, default = 1%
##	      maxIter: max ## iterations in repeating bic.glm
##             maxNvar: max ## variables to feed into bic.glm, default=30
## returns: an object of class bic.glm if the algorithm finishes
## 	   output from applying bic.glm on selected variables
##	   otherwise, returns -1

iterateBMAglm.wrapper <- function (sortedA, y, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1) {
  ## get the top "maxNvar" variables
  ret.bma.init <- iterateBMAinit (x=sortedA, maxNvar)

  ## call bic.glm repeatedly
  ret.bma <- iterateBMAglm (x=sortedA, y=y, curr.mat=ret.bma.init$curr.mat, stopVar=ret.bma.init$stopVar, nextVar=ret.bma.init$nextVar, nbest, thresProbne0, maxNvar, maxIter)

  if (ret.bma$stopVar == 1) {
     ## apply bic.glm again using selected genes
     ret.bic.glm <- bic.glm (x=ret.bma$curr.mat, y=y, maxCol=(maxNvar+1), glm.family="binomial", nbest=nbest)
     return (ret.bic.glm)
  } else {
     return (-1)
  }
}


########################################################


iterateBMAglm.train <- function (train.expr.set, train.class, p=100, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1) {

  train.dat <- t(exprs(train.expr.set))
  ## 1. order all the columns (variables) by BSS/WSS ratios
  sorted.vec <- BssWssFast (train.dat, train.class, numClass = 2)
  sorted.train.dat <- train.dat[, sorted.vec$ix[1:p]]
 
  ## 2. run iterative bic.glm
  ## run iterative BMA using logistic regression
  ret.bma <- iterateBMAglm.wrapper (sorted.train.dat, y=train.class, nbest=nbest, maxNvar=maxNvar, maxIter=maxIter, thresProbne0=thresProbne0)

  # convert gene names in "namesx" and "label"
  ret.bma$namesx <- as.character(sapply (ret.bma$namesx, convertSingleName, orig.expr.set=train.expr.set))
  ret.bma$label <- as.character(sapply (ret.bma$label, convertModelName, orig.expr.set=train.expr.set))
  ret.bma
}


iterateBMAglm.train.predict <- function (train.expr.set, test.expr.set, train.class, p=100, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1) {

  train.dat <- t(exprs(train.expr.set))
  test.dat <- t(exprs(test.expr.set))
  ## use the training data to select relevant genes
  ret.bma <- iterateBMAglm.train (train.expr.set, train.class, p, nbest, maxNvar, maxIter, thresProbne0)

  ## predict the classes of the test samples using the selected genes
  if (nrow(test.dat) > 1) {
     curr.test.dat <- test.dat [, ret.bma$namesx]
  } else {    # for LOOCV
     curr.test.dat <- matrix(test.dat [, ret.bma$namesx], ncol=length(ret.bma$namesx), dimnames=list(NULL, ret.bma$namesx))
  }
  y.pred.test <- apply (curr.test.dat, 1, bma.predict, postprobArr=ret.bma$postprob, mleArr=ret.bma$mle)
}


iterateBMAglm.train.predict.test <- function (train.expr.set, test.expr.set, train.class, test.class, p=100, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1) {

  train.dat <- t(exprs(train.expr.set))
  test.dat <- t(exprs(test.expr.set))
  ## use the training data to select relevant genes
  ret.bma <- iterateBMAglm.train (train.expr.set, train.class, p, nbest, maxNvar, maxIter, thresProbne0)

  ## predict the classes of the test samples using the selected genes
  if (nrow(test.dat) > 1) {
     curr.test.dat <- test.dat [, ret.bma$namesx]
  } else {    # for LOOCV
     curr.test.dat <- matrix(test.dat [, ret.bma$namesx], ncol=length(ret.bma$namesx), dimnames=list(NULL, ret.bma$namesx))
  }
  y.pred.test <- apply (curr.test.dat, 1, bma.predict, postprobArr=ret.bma$postprob, mleArr=ret.bma$mle)

  ## compute the number of errors and brier score
  curr.table <- table (round(y.pred.test, 0), test.class)
  curr.error <- sum (curr.table) - sum(diag(curr.table))
  ## print (curr.table)
  ## compute the brier score
  ## print (round(y.pred.test, 3))
  curr.score <- brier.score (y.pred.test, test.class)
  ## print (curr.score)

  selected.genes <- which (ret.bma$probne0 > 0)
  ## print (paste("# selected genes = ", length(selected.genes), sep=""))
  ## print (paste("# selected models = ", length(ret.bma$postprob), sep=""))
  list (num.genes=length(selected.genes), num.model=length(ret.bma$postprob), num.err=curr.error, brierScore=curr.score)

}

## BssWssFast: compute the ratio of between-group to within group sum of squares
## arguments: X is a matrix where columns are variables, rows are observations
## return values: a vector of sorted (in descending order) ratio's and their ranks
## to get the top N variables: X[, sortedvec$ix[1:N]]

BssWssFast <- function (X, givenClassArr, numClass = 2) {
       
       ## create indicator variables for each class
       ## assume class numbers start from 0
       classVec <- matrix (0, numClass, length (givenClassArr))
       for (k in 1: numClass) {
           temp <- rep(0, length(givenClassArr))
       	   temp [givenClassArr == (k-1)] <- 1
	   classVec[k, ] <- temp
       }

       ## compute BSS/WSS for each variable
       classMeanArr <- rep(0, numClass)
       ratio <- rep (0, ncol(X))
       for (j in 1: ncol(X)) {
       	   ## compute mean across all samples
	   overallMean <- sum (X[, j])/length(X[, j])
	   ## compute class mean for variable j
	   for (k in 1: numClass) {
	       classMeanArr[k] <- sum(classVec[k, ] * X[, j])/sum(classVec[k, ])
       	   }
	   ## to re-write classMeanArr as a vector containing class mean for each entry
	   classMeanVec <- classMeanArr[givenClassArr+1]

	   ## compute BSS and WSS
	   bss <- sum( (classMeanVec - overallMean)^2)
	   wss <- sum( (X[, j] - classMeanVec)^2)
	   ratio[j] <- bss/wss
       } 
       sort (ratio, decreasing=TRUE, index = TRUE)
}

# define the punctunation character string
bma.punct.string <- "-|/|\\.|#|&|\\*|'|~|\\{|\\}|\\(|\\)|:|;|\\+|=|%|$"

# to convert gene names from "namesx" of an bic.glm object to original gene names
convertSingleName <- function (curr.name, orig.expr.set) {
  curr.string <- unlist(strsplit (curr.name, bma.punct.string))
  ret.string <- curr.name

  # only need to convert if the string contains the period
  # map the R processed gene name back to what is in the original ExpressionSet
  if (length (curr.string) > 1) {
    match.vec <- sapply (dimnames(exprs(orig.expr.set))[[1]], function (x) {
      temp.string <- unlist(strsplit (x, bma.punct.string))
      if (length(temp.string) == length(curr.string)) {
        ret.val <- all (temp.string == curr.string)
      } else {
        ret.val <- FALSE
      }
      ret.val})
    temp.ind <- which (match.vec == T)
    if (length(temp.ind) == 1) {
      # exactly 1 match
      ret.string <- names(match.vec[temp.ind])
    } 
  }
  ret.string
}


# to convert model namess from "label" of an bic.glm object to original gene names
convertModelName <- function (curr.model, orig.expr.set) {
  model.arr <- unlist (strsplit (curr.model, ","))
  ret.names <- sapply (model.arr, convertSingleName, orig.expr.set=orig.expr.set)
  paste (ret.names, collapse=",")
}

## goal: to plot image plot without variables with probne0 == 0
## and variables sorted by probne0 in descending order
## arguments: same as imageplot.bma
## calls imageplot.bma

imageplot.iterate.bma <- function (bicreg.out, color="default", ...) {
   
   ## get genes with non-zero probne0
   selected.genes <- bicreg.out$namesx [bicreg.out$probne0 > 0]
   selected.probne0 <- bicreg.out$probne0 [bicreg.out$probne0 > 0]
   ## sort by probne0
   sorted.vec <- sort (selected.probne0, decreasing=TRUE, index = TRUE)
   sorted.genes <- selected.genes [sorted.vec$ix]

   ## modify components in bicreg.out: namesx, probne0, n.vars, which
   bicreg.mod.out <- bicreg.out
   bicreg.mod.out$namesx <- sorted.genes
   bicreg.mod.out$probne0 <- sorted.vec$x
   bicreg.mod.out$n.vars <- length (sorted.genes)
   ## do NOT sort the columns in which
   bicreg.mod.out$which <- bicreg.out$which [, bicreg.out$probne0 > 0]
   bicreg.mod.out$which <- bicreg.mod.out$which[, sorted.vec$ix]

   ## calls imageplot.bma with the modified argument
   imageplot.bma.mod (bicreg.mod.out, color=color)
}


## code copied from imageplot.bma from the BMA package
## with a few modifications: margin of plot
## and title of plot
imageplot.bma.mod <- function (bicreg.out, color = "default", ...)  {
    keep.mar <- par()$mar
    par(mar = c(5, 8, 4, 2) + 0.1)
    which.out <- bicreg.out$which
    nvar <- ncol(which.out)
    nmodel <- nrow(which.out)
    par(las = 1)
    if (color == "default") {
        image(c(0, cumsum(bicreg.out$postprob)), 1:nvar, -which.out[1:nmodel, 
            nvar:1, drop = FALSE], xlab = "Model #", ylab = "", 
            xaxt = "n", yaxt = "n", xlim = c(0, 1), main = "Models selected by iterativeBMA", 
            ...)
    }
    if (color == "blackandwhite") {
        image(cumsum(bicreg.out$postprob), 1:nvar, -which.out[1:nmodel, 
            nvar:1, drop = FALSE], xlab = "Model #", ylab = "", 
            xaxt = "n", yaxt = "n", col = c("black", "white"), 
            main = "Models selected by BMA", ...)
    }
    xat <- (cumsum(bicreg.out$postprob) + c(0, cumsum(bicreg.out$postprob[-nmodel])))/2
    axis(1, at = xat, labels = 1:nmodel, ...)
    axis(2, at = 1:nvar, labels = rev(bicreg.out$namesx), ...)
    par(mar = keep.mar)
}

## goal: compute the posterior probability of Pr[Y=1 | D]
## Pr[Y=1|D] = sum_k postprob_k * (e^sum / 1+ e^sum)
## where sum = sum_j beta_k^j * Xj 
## where beta_k^j is the mle est of variable j in model k
## arguments: postprobArr = postprob from bic.glm
##	     mleArr = mle from bic.glm
##	     newdataArr = vector of test data (1 observation)
## value = NA if newdataArr contains NA

maxExpValueKY <- 700
minExpValueKY <- -700

bma.predict <- function (newdataArr, postprobArr, mleArr) {
       nModel <- length (postprobArr)
       ## sum over each model k
       retprob <- 0
       if (any(is.na(newdataArr))) {
       	  retprob <- NA
       } else {
       	 for (k in 1: nModel) {
           ## sum over all variables, assume the first mle is the intercept
	   myexp <- mleArr[k,1] + sum (mleArr[k,-1] * newdataArr)
           if (myexp > 0) {
              myexp <- min (myexp, maxExpValueKY)
           } else {
              myexp <- max (myexp, minExpValueKY)
           } 
	   myexpval <- exp (myexp)
	   retprob <- retprob + (postprobArr[k] * (myexpval / (1+ myexpval)))
       	 }
       }
       retprob
}

## goal: to summarize pi^ (predicted P[Y=1]) using different scores

## for 2 classes only
## Brier score = sum_i (y_i - p_i^)^2

brier.score <- function (predictedArr, truthArr) {
	## make sure the 2 arrays are the same length
	if (length(predictedArr) != length(truthArr)) {
	   print ("ERROR: length NOT equal!!")
        }
 	## sum over all the samples
	temp.vec <- (truthArr - predictedArr)^2
	sum (temp.vec)
}

\name{iterateBMAglm.train}
\alias{iterateBMAglm.train}
\title{Iterative Bayesian Model Averaging: training step}
\description{Classification and variable selection on microarray data.
	     This is a multivariate technique to select a small number
	     of relevant variables (typically genes) to classify
	     microarray samples.  This function performs the training phase.
	     The data is assumed to consist of
	     two classes. Logistic regression is used for classification.}
\usage{iterateBMAglm.train (train.expr.set, train.class, p=100, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1)}

\arguments{
\item{train.expr.set}{an \code{ExpressionSet} object.
		 We assume the rows in the expression data represent variables (genes), 
		 while the columns  represent 
		 samples or experiments. This training data is used to
		 select relevant genes (variables) for classification.}
\item{train.class}{class vector for the observations (samples or 
                   experiments) in the training data. 
		   Class numbers are assumed to start from 0,
		   and the length of this class vector should be equal
		   to the number of rows in train.dat.
		   Since we assume 2-class data, we expect the class vector
		   consists of zero's and one's.}
\item{p}{a number indicating the maximum number of top univariate genes
	 used in the iterative BMA algorithm.  This number is assumed to be
	 less than the total number of genes in the training data.
	 A larger p usually requires longer computational time as more
	 iterations of the BMA algorithm are potentially applied.
	 The default is 100.}
\item{nbest}{a number specifying the number of models of each size 
             returned to \code{bic.glm} in the \code{BMA} package. 
	     The default is 10.}
\item{maxNvar}{a number indicating the maximum number of variables used in
	       each iteration of \code{bic.glm} from the \code{BMA} package.
	       The default is 30.}
\item{maxIter}{a number indicating the maximum of iterations of 
               \code{bic.glm}. The default is 20000.}
\item{thresProbne0}{a number specifying the threshold for the posterior
                    probability that each variable (gene) is non-zero (in
		    percent).  Variables (genes) with such posterior 
		    probability less than this threshold are dropped in
		    the iterative application of \code{bic.glm}.  The default
		    is 1 percent.}
}

\details{The training phase consists of first
	 ordering all the variables (genes) by a univariate measure
	 called between-groups to within-groups sums-of-squares (BSS/WSS)
	 ratio, and then iteratively applying the \code{bic.glm} algorithm
	 from the \code{BMA} package.  In the first application of
	 the \code{bic.glm} algorithm, the top \code{maxNvar} univariate
	 ranked genes are used.  After each application of the \code{bic.glm}
	 algorithm, the genes with \code{probne0} < \code{thresProbne0}
	 are dropped, and the next univariate ordered genes are added
	 to the BMA window.}

\value{An object of class \code{bic.glm} returned by the last iteration
       of \code{bic.glm}.  The object is a list consisting of
       the following components:
\item{namesx}{the names of the variables in the last iteration of 
              \code{bic.glm}.}
\item{postprob}{the posterior probabilities of the models selected.}
\item{deviance}{the estimated model deviances.}
\item{label}{labels identifying the models selected.}
\item{bic}{values of BIC for the models.}
\item{size}{the number of independent variables in each of the models.}
\item{which}{a logical matrix with one row per model and one column per 
             variable indicating whether that variable is in the model.}
\item{probne0}{the posterior probability that each variable is non-zero 
               (in percent).}
\item{postmean}{the posterior mean of each coefficient (from model averaging).}
\item{postsd}{the posterior standard deviation of each coefficient 
              (from model averaging).}
\item{condpostmean}{the posterior mean of each coefficient conditional on 
                    the variable being included in the model.}
\item{condpostsd}{the posterior standard deviation of each coefficient 
                  conditional on the variable being included in the model.}
\item{mle}{matrix with one row per model and one column per variable giving 
           the maximum likelihood estimate of each coefficient for each model.}
\item{se}{matrix with one row per model and one column per variable giving 
          the standard error of each coefficient for each model.}
\item{reduced}{a logical indicating whether any variables were dropped 
               before model averaging.}
\item{dropped}{a vector containing the names of those variables dropped 
               before model averaging.}
\item{call}{the matched call that created the bma.lm object.}
}

\references{
Raftery, A.E. (1995). 
Bayesian model selection in social research (with Discussion). Sociological Methodology 1995 (Peter V. Marsden, ed.), pp. 111-196, Cambridge, Mass.: Blackwells.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{The \code{BMA} and \code{Biobase} packages are required.}

\seealso{\code{\link{iterateBMAglm.train.predict}},  
	 \code{\link{iterateBMAglm.train.predict.test}},
	 \code{\link{bma.predict}},
	 \code{\link{brier.score}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)

## training phase: select relevant genes
ret.bic.glm <- iterateBMAglm.train (train.expr.set=trainData, trainClass, p=100)

## get the selected genes with probne0 > 0
ret.gene.names <- ret.bic.glm$namesx[ret.bic.glm$probne0 > 0]

## show the posterior probabilities of selected models
ret.bic.glm$postprob

data (testData)

## get the subset of test data with the genes from the last iteration of bic.glm
curr.test.dat <- t(exprs(testData)[ret.gene.names,])

## to compute the predicted probabilities for the test samples
y.pred.test <- apply (curr.test.dat, 1, bma.predict, postprobArr=ret.bic.glm$postprob, mleArr=ret.bic.glm$mle)

## compute the Brier Score if the class labels of the test samples are known
data (testClass)
brier.score (y.pred.test, testClass)
}
\keyword{multivariate}
\keyword{classif}

\name{bma.predict}
\alias{bma.predict}
\title{Predicted Probabilities from Bayesian Model Averaging}
\description{This function computes the predicted posterior probability 
             that each test sample belongs to class 1.  It assumes
             2-class data, and requires the true class labels to be known.}
\usage{bma.predict (newdataArr, postprobArr, mleArr)}

\arguments{
\item{newdataArr}{a vector consisting of the data from a test sample.}
\item{postprobArr}{a vector consisting of the posterior probability
                   of each BMA selected model.}
\item{mleArr}{matrix with one row per model and one column per variable giving 
              the maximum likelihood estimate of each coefficient for each 
              BMA selected model.}
}

\details{Let Y be the response variable (class labels for samples in our
         case).  In Bayesian Model Averaging (BMA), the posterior 
	 probability of Y=1 given the training set is the weighted 
	 average of the posterior probability of Y=1 given the training set 
	 and model M multiplied by the posterior probability of model M 
	 given the training set, summing over a set of models M.}

\value{A real number between zero and one, representing the predicted
       posterior probability.}

\references{
Raftery, A.E. (1995). 
Bayesian model selection in social research (with Discussion). Sociological Methodology 1995 (Peter V. Marsden, ed.), pp. 111-196, Cambridge, Mass.: Blackwells.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{}

\seealso{\code{\link{brier.score}},
         \code{\link{iterateBMAglm.train}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)

## training phase: select relevant genes
ret.bic.glm <- iterateBMAglm.train (train.expr.set=trainData, trainClass, p=100)

## get the selected genes with probne0 > 0
ret.gene.names <- ret.bic.glm$namesx[ret.bic.glm$probne0 > 0]

data (testData)

## get the subset of test data with the genes from the last iteration of bic.glm
curr.test.dat <- t(exprs(testData)[ret.gene.names,])

## to compute the predicted probabilities for the test samples
y.pred.test <- apply (curr.test.dat, 1, bma.predict, postprobArr=ret.bic.glm$postprob, mleArr=ret.bic.glm$mle)

## compute the Brier Score if the class labels of the test samples are known
data (testClass)
brier.score (y.pred.test, testClass)

}
\keyword{classif}

\name{iterateBMAglm.wrapper}
\alias{iterateBMAglm.wrapper}
\title{Iterative Bayesian Model Averaging}
\description{This function repeatedly calls \code{bic.glm} from the
	     \code{BMA} package until all variables are exhausted.
	     The data is assumed to consist of
	     two classes. Logistic regression is used for classification.}
\usage{iterateBMAglm.wrapper (sortedA, y, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1) }

\arguments{
\item{sortedA}{data matrix where columns are variables and rows are 
	       observations.  The variables (columns) are assumed to
	       be sorted using a univariate measure.
               In the case of gene expression data, the columns (variables) 
	       represent genes, while the rows (observations) represent 
	       samples or experiments.}
\item{y}{class vector for the observations (samples or 
         experiments) in the training data. 
	 Class numbers are assumed to start from 0,
	 and the length of this class vector should be equal
	 to the number of rows in sortedA.
	 Since we assume 2-class data, we expect the class vector
	 consists of zero's and one's.}
\item{nbest}{a number specifying the number of models of each size 
             returned to \code{bic.glm} in the \code{BMA} package. 
	     The default is 10.}
\item{maxNvar}{a number indicating the maximum number of variables used in
	       each iteration of \code{bic.glm} from the \code{BMA} package.
	       The default is 30.}
\item{maxIter}{a number indicating the maximum of iterations of 
               \code{bic.glm}. The default is 20000.}
\item{thresProbne0}{a number specifying the threshold for the posterior
                    probability that each variable (gene) is non-zero (in
		    percent).  Variables (genes) with such posterior 
		    probability less than this threshold are dropped in
		    the iterative application of \code{bic.glm}.  The default
		    is 1 percent.}
}

\details{In this function, the variables are assumed to be sorted, and
	 \code{bic.glm} is called repeatedly.  In the first application of
	 the \code{bic.glm} algorithm, the top \code{maxNvar} univariate
	 ranked genes are used.  After each application of the \code{bic.glm}
	 algorithm, the genes with \code{probne0} < \code{thresProbne0}
	 are dropped, and the next univariate ordered genes are added
	 to the BMA window.
	 The function \code{iterateBMAglm.train} calls \code{BssWssFast} before
	 calling this function.
	 Using this function, users can experiment with alternative 
	 univariate measures.}

\value{If all variables are exhausted, an object of class 
       \code{bic.glm} returned by the last iteration
       of \code{bic.glm}. Otherwise, -1 is returned. 
       The object of class \code{bic.glm} is a list consisting 
       of the following components:
\item{namesx}{the names of the variables in the last iteration of 
              \code{bic.glm}.}
\item{postprob}{the posterior probabilities of the models selected.}
\item{deviance}{the estimated model deviances.}
\item{label}{labels identifying the models selected.}
\item{bic}{values of BIC for the models.}
\item{size}{the number of independent variables in each of the models.}
\item{which}{a logical matrix with one row per model and one column per 
             variable indicating whether that variable is in the model.}
\item{probne0}{the posterior probability that each variable is non-zero 
               (in percent).}
\item{postmean}{the posterior mean of each coefficient (from model averaging).}
\item{postsd}{the posterior standard deviation of each coefficient 
              (from model averaging).}
\item{condpostmean}{the posterior mean of each coefficient conditional on 
                    the variable being included in the model.}
\item{condpostsd}{the posterior standard deviation of each coefficient 
                  conditional on the variable being included in the model.}
\item{mle}{matrix with one row per model and one column per variable giving 
           the maximum likelihood estimate of each coefficient for each model.}
\item{se}{matrix with one row per model and one column per variable giving 
          the standard error of each coefficient for each model.}
\item{reduced}{a logical indicating whether any variables were dropped 
               before model averaging.}
\item{dropped}{a vector containing the names of those variables dropped 
               before model averaging.}
\item{call}{the matched call that created the bma.lm object.}
}

\references{
Raftery, A.E. (1995). 
Bayesian model selection in social research (with Discussion). Sociological Methodology 1995 (Peter V. Marsden, ed.), pp. 111-196, Cambridge, Mass.: Blackwells.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{The \code{BMA} and \code{Biobase} packages are required.}

\seealso{\code{\link{iterateBMAglm.train}},  
	 \code{\link{iterateBMAglm.train.predict}},
	 \code{\link{iterateBMAglm.train.predict.test}},
	 \code{\link{BssWssFast}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)

## Use the BSS/WSS ratio to rank all genes in the training data
sorted.vec <- BssWssFast (t(exprs(trainData)), trainClass, numClass = 2)
## get the top ranked 50 genes
sorted.train.dat <- t(exprs(trainData[sorted.vec$ix[1:50], ]))
 
## run iterative bic.glm
ret.bic.glm <- iterateBMAglm.wrapper (sorted.train.dat, y=trainClass)

## The above commands are equivalent to the following 
ret.bic.glm <- iterateBMAglm.train (train.expr.set=trainData, trainClass, p=50)

}
\keyword{multivariate}
\keyword{classif}

\name{testData}
\docType{data}
\alias{testData}
\title{Sample Test Data for the Iterative BMA Algorithm}
\description{
This is an adapted leukemia (ALL, AML) \code{ExpressionSet} from Golub et al. (1999).
This \code{ExpressionSet} consists of the expression levels from 38 ALL or AML samples
(rows), and 100  genes (columns).  This dataset is used
as an example test data in our examples.
}
\usage{data(testData)}
\format{The \code{ExpressionSet} is called \code{testData}. Each entry
in the matrix represents the expression level of one gene from an ALL
or AML sample.
}
\details{
For illustration purposes, a subset of  100 genes from the package \code{golubEsets}
 is included in this package.
} 
\source{
The \code{golubEsets} bioconductor data package, or
\url{http://www.broad.mit.edu/cgi-bin/cancer/datasets.cgi}.
}
\references{
Golub, T.R., Slonim, D.K., Tamayo, P., Huard, C., Gaasenbeek, M., Mesirov, J.P., Coller, H., Loh, M.L., Downing, J.R., Caligiuri, M.A., et al. (1999) 
Molecular classification of cancer: class discovery and class prediction by gene expression monitoring. Science 286: 531-7.
}
\keyword{datasets}

\name{iterateBMAglm.train.predict}
\alias{iterateBMAglm.train.predict}
\title{Iterative Bayesian Model Averaging: training and prediction}
\description{Classification and variable selection on microarray data.
	     This is a multivariate technique to select a small number
	     of relevant variables (typically genes) to classify
	     microarray samples.  This function performs the training,
	     and prediction steps.  The data is assumed to consist of
	     two classes. Logistic regression is used for classification.}
\usage{iterateBMAglm.train.predict (train.expr.set, test.expr.set, train.class, p=100, nbest=10, maxNvar=30, maxIter=20000, thresProbne0=1)}

\arguments{
\item{train.expr.set}{an \code{ExpressionSet} object.
		 We assume the rows in the expression data represent variables (genes), 
		 while the columns  represent 
		 samples or experiments. This training data is used to
		 select relevant genes (variables) for classification.}
\item{test.expr.set}{an \code{ExpressionSet} object.
		 We assume the rows in the expression data represent variables (genes), 
		 while the columns  represent samples or experiments.
		  The variables selected using the
		training data is used to classify samples on this test data.}
\item{train.class}{class vector for the observations (samples or 
                   experiments) in the training data. 
		   Class numbers are assumed to start from 0,
		   and the length of this class vector should be equal
		   to the number of rows in train.dat.
		   Since we assume 2-class data, we expect the class vector
		   consists of zero's and one's.}
\item{p}{a number indicating the maximum number of top univariate genes
	 used in the iterative BMA algorithm.  This number is assumed to be
	 less than the total number of genes in the training data.
	 A larger p usually requires longer computational time as more
	 iterations of the BMA algorithm are potentially applied.
	 The default is 100.}
\item{nbest}{a number specifying the number of models of each size 
             returned to \code{bic.glm} in the \code{BMA} package. 
	     The default is 10.}
\item{maxNvar}{a number indicating the maximum number of variables used in
	       each iteration of \code{bic.glm} from the \code{BMA} package.
	       The default is 30.}
\item{maxIter}{a number indicating the maximum of iterations of 
               \code{bic.glm}. The default is 20000.}
\item{thresProbne0}{a number specifying the threshold for the posterior
                    probability that each variable (gene) is non-zero (in
		    percent).  Variables (genes) with such posterior 
		    probability less than this threshold are dropped in
		    the iterative application of \code{bic.glm}.  The default
		    is 1 percent.}
}

\details{This function consists of the training phase and the prediction 
         phase.  The training phase consists of first
	 ordering all the variables (genes) by a univariate measure
	 called between-groups to within-groups sums-of-squares (BSS/WSS)
	 ratio, and then iteratively applying the \code{bic.glm} algorithm
	 from the \code{BMA} package.  The prediction phase uses the variables
	 (genes) selected in the training phase to classify the samples
	 in the test set. }

\value{A vector consisting of the predicted probability that each test 
       sample belongs to class 1 is returned.}

\references{
Raftery, A.E. (1995). 
Bayesian model selection in social research (with Discussion). Sociological Methodology 1995 (Peter V. Marsden, ed.), pp. 111-196, Cambridge, Mass.: Blackwells.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{The \code{BMA} and \code{Biobase} packages are required.}

\seealso{\code{\link{iterateBMAglm.train}},  
	 \code{\link{iterateBMAglm.train.predict.test}},
	 \code{\link{brier.score}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)
data (testData)

ret.vec <- iterateBMAglm.train.predict (train.expr.set=trainData, test.expr.set=testData, trainClass, p=100)

## compute the Brier Score
data (testClass)
brier.score (ret.vec, testClass)

}
\keyword{multivariate}
\keyword{classif}

\name{iterativeBMA-internal}
\alias{iterativeBMA-internal}
\alias{iterateBMAglm}
\alias{iterateBMAinit}
\alias{maxExpValueKY}
\alias{minExpValueKY}
\alias{zero.threshold}
\alias{imageplot.bma.mod}
\alias{convertSingleName}
\alias{convertModelName}
\alias{bma.punct.string}

\title{Internal functions for iterativeBMA}
\description{Internal functions for \code{iterativeBMA}, not meant to be called directly.}

\usage{
iterateBMAglm (x, y, curr.mat, stopVar=0, nextVar, nbest=10, thresProbne0 = 1, maxNvar = 30, maxIter=20000)
iterateBMAinit (x, maxNvar = 30)
imageplot.bma.mod (bicreg.out, color = "default", ...)
convertSingleName (curr.name, orig.expr.set)
convertModelName (curr.model, orig.expr.set)
maxExpValueKY
minExpValueKY
zero.threshold
bma.punct.string
}
\keyword{internal}

\name{imageplot.iterate.bma}
\alias{imageplot.iterate.bma}
\title{An image plot visualization tool}
\description{Create a visualization of the models and variables selected by the
             iterative BMA algorithm.}
\usage{imageplot.iterate.bma (bicreg.out, color="default", ...)}

\arguments{
\item{bicreg.out}{An object of type 'bicreg', 'bic.glm' or 'bic.surv'}
\item{color}{The color of the plot. The value "default" uses the 
             current default R color scheme for image. The value 
             "blackandwhite" produces a black and white image.}
\item{...}{Other parameters to be passed to the image and axis functions.}
}

\details{This function is a modification of the \code{imageplot.bma}
         function from the \code{BMA} package. The difference is that
	 variables (genes) with \code{probne0} equal to 0 are removed
	 before plotting. The arguments of this function is identical
	 to those in \code{imageplot.bma}.}

\value{An heatmap-style image, with the BMA selected variables on the vertical
       axis, and the BMA selected models on the horizontal axis. The variables
       (genes) are sorted in descreasing order of the posterior probability 
       that the variable is not equal to 0 (\code{probne0}) from top to 
       bottom.  The models are sorted in descreasing order of the
       model posterior probability (\code{postprob}) from left to right.
       }

\references{
Clyde, M. (1999) 
Bayesian Model Averaging and Model Search Strategies (with discussion). In Bayesian Statistics 6. J.M. Bernardo, A.P. Dawid, J.O. Berger, and A.F.M. Smith eds. Oxford University Press, pages 157-185.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{The \code{BMA} and \code{Biobase} packages are required.}

\seealso{\code{\link{iterateBMAglm.train}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)

## training phase: select relevant genes
ret.bic.glm <- iterateBMAglm.train (train.expr.set=trainData, trainClass, p=100)

## produce an image plot to visualize the selected genes and models
imageplot.iterate.bma (ret.bic.glm)

}
\keyword{classif}

\name{brier.score}
\alias{brier.score}
\title{Brier Score: assessment of prediction accuracy}
\description{The Brier Score is a probabilistic number of errors that takes
	     the predicted probabilities into consideration. A small Brier
	     Score indicates high prediction accuracy. This function assumes
             2-class data, and requires the true class labels to be known.}
\usage{brier.score (predictedArr, truthArr)}

\arguments{
\item{predictedArr}{a vector consisting of the predicted probabilities
                    that the test sample belongs to class 1.}
\item{truthArr}{a zero-one vector indicating the known class labels of
                the test samples. We assume this vector has the same
		length as \code{predictedArr}.}
}

\details{The Brier Score computes the sum of squares of the differences 
         between the true class and the predicted probability over all 
         test samples. If the predicted probabilities are constrained 
         to equal to 0 or 1, the Brier Score is equal to the total 
         number of classification errors.}

\value{A non-negative real number.}

\references{
Brier, G.W. (1950) 
Verification of forecasts expressed in terms of probability. Monthly Weather Review 78: 1-3.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{}

\seealso{\code{\link{bma.predict}},
         \code{\link{iterateBMAglm.train.predict}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)
data (testData)

ret.vec <- iterateBMAglm.train.predict (train.expr.set=trainData, test.expr.set=testData, trainClass, p=100)

## compute the Brier Score
data (testClass)
brier.score (ret.vec, testClass)

}
\keyword{classif}

\name{trainClass}
\docType{data}
\alias{trainClass}
\title{Sample Training Data for the Iterative BMA Algorithm}
\description{
This is an adapted leukemia (ALL, AML) dataset from Golub et al. (1999).
This is a zero-one vector for 38 training samples.  Class 0 represents
an ALL sample, while class 1 represents an AML sample.
}
\usage{data(trainClass)}
\format{The vector is called \code{trainClass}. 
}
\details{
} 
\source{
The \code{golubEsets} bioconductor data package, or
\url{http://www.broad.mit.edu/cgi-bin/cancer/datasets.cgi}.
}
\references{
Golub, T.R., Slonim, D.K., Tamayo, P., Huard, C., Gaasenbeek, M., Mesirov, J.P., Coller, H., Loh, M.L., Downing, J.R., Caligiuri, M.A., et al. (1999) 
Molecular classification of cancer: class discovery and class prediction by gene expression monitoring. Science 286: 531-7.
}
\keyword{datasets}

\name{BssWssFast}
\alias{BssWssFast}
\title{Between-groups sum-of-squares to within-groups sum-of-squares
       ratio}
\description{This is a univariate technique to select relevant
	     genes in classification of microarray data. In classifying
	     samples of microarray data, this ratio is computed for each
	     gene.  A large between-groups to within-groups sum-of-squares 
	     ratio indicates a potentially relevant gene.}
\usage{BssWssFast (X, givenClassArr, numClass = 2)}

\arguments{
\item{X}{data matrix where columns are variables and rows are observations.
         In the case of gene expression data, the columns (variables) represent
	 genes, while the rows (observations) represent samples or experiments.}
\item{givenClassArr}{class vector for the observations (samples or 
                     experiments). Class numbers are assumed to start from 0,
		     and the length of this class vector should be equal
		     to the number of rows in X.
		     In the case of 2-class data, we expect the class vector
		     consists of zero's and one's.}
\item{numClass}{number of classes. The default is 2.}
}

\details{This function is called by \code{iterateBMAglm.2class}.}

\value{A list of 2 elements are returned:
\item{x}{A vector containing the BSS/WSS ratios in descending order.}
\item{ix}{A vector containing the indices corresponding to the sorted ratios.}
}

\references{
Dudoit, S., Fridlyand, J. and Speed, T.P. (2002) Comparison of discrimination methods for the classification of tumors using gene expression data. Journal of the American Statistical Association 97: 77-87.

Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\note{}

\seealso{\code{\link{iterateBMAglm.train}},  \code{\link{trainData}},
	 \code{\link{trainClass}}}

\examples{
data(trainData)
data(trainClass)

ret.bsswss <- BssWssFast (X=t(exprs(trainData)), givenClassArr=trainClass, numClass = 2)

}
\keyword{univar}

\name{iterativeBMA-package}
\alias{iterativeBMA-package}
\alias{iterativeBMA}
\docType{package}
\title{
The Iterative Bayesian Model Averaging (BMA) algorithm
}
\description{
The iterative Bayesian Model Averaging (BMA) algorithm is a variable 
selection and classification algorithm with an application of 
classifying 2-class microarray samples, as described in Yeung, 
Bumgarner and Raftery (Bioinformatics 2005, 21: 2394-2402).
}
\details{
\tabular{ll}{
Package: \tab iterativeBMA\cr
Type: \tab Package\cr
Version: \tab 0.1.0\cr
Date: \tab 2005-12-30\cr
License: \tab GPL version 2 or higher\cr
}
The function \code{iterateBMAglm.train} selects relevant variables by
iteratively applying the \code{bic.glm} function from the \code{BMA} package.
The data is assumed to consist of two classes. 
The function \code{iterateBMAglm.train.predict} combines the training
and prediction phases, and returns the predicted posterior probabilities
that each test sample belongs to class 1.
The function \code{iterateBMAglm.train.predict.test} combines the training,
prediction and test phases, and returns a list consisting of the
numbers of selected genes and models using the training data, the number
of classification errors and the Brier Score on the test set.
}
\author{
Ka Yee Yeung, University of Washington, Seattle, WA, with
contributions from Adrian Raftery and Ian Painter

Maintainer: Ka Yee Yeung <kayee@u.washington.edu>
}
\references{
Yeung, K.Y., Bumgarner, R.E. and Raftery, A.E. (2005) 
Bayesian Model Averaging: Development of an improved multi-class, gene selection and classification tool for microarray data. 
Bioinformatics 21: 2394-2402.
}
\keyword{multivariate}
\keyword{classif}

\seealso{\code{\link{iterateBMAglm.train.predict}},  
	 \code{\link{iterateBMAglm.train.predict.test}},
	 \code{\link{bma.predict}},
	 \code{\link{brier.score}}
}

\examples{
library (Biobase)
library (BMA)
library (iterativeBMA)
data(trainData)
data(trainClass)

## training phase: select relevant genes
ret.bic.glm <- iterateBMAglm.train (train.expr.set=trainData, trainClass, p=100)

## get the selected genes with probne0 > 0
ret.gene.names <- ret.bic.glm$namesx[ret.bic.glm$probne0 > 0]

data (testData)

## get the subset of test data with the genes from the last iteration of bic.glm
curr.test.dat <- t(exprs(testData)[ret.gene.names,])

## to compute the predicted probabilities for the test samples
y.pred.test <- apply (curr.test.dat, 1, bma.predict, postprobArr=ret.bic.glm$postprob, mleArr=ret.bic.glm$mle)

## compute the Brier Score if the class labels of the test samples are known
data (testClass)
brier.score (y.pred.test, testClass)
}
